CREATE OR REPLACE procedure opt_lock_cupdate (
   iempno in varchar2 default null,
   iename in varchar2 default null,
   ijob in varchar2 default null,
   iold_checksum in varchar2 default null,
   irowid in varchar2 default null) is

   new_checksum number;

begin

   new_checksum := owa_opt_lock.checksum('SCOTT', 'emp', irowid);
   htp.print(new_checksum);
   if iold_checksum = new_checksum then
      -- Perform the update
      update scott.emp set
         emp.ename = iename,
         emp.job = ijob
      where
         emp.empno = iempno;
      commit;
      htp.print('<h1>Change Successful</h1>');
   else
      htp.print('<h1>The record has been changed!</h1>');
   end if;
EXCEPTION
   when others then
      htp.print(dbms_utility.format_error_stack);   
end; 
/

