CREATE OR REPLACE procedure tokenize (sentence in varchar2 default 'This is a test' ) is
   mline owa_text.multi_line;
   i number;
   N number;
   c varchar2(1);
begin
   N := length (sentence);
   owa_text.new_multi (mline);  -- initialize the structure
   for i in 1..N loop
      c := substr (sentence,i,1); -- fetch current character
      if c = ' ' then
         -- Add a new row if the character is a space
         owa_text.add2multi(c, mline, FALSE);
      else
         -- Otherwise, append the character to the end of the string
         owa_text.add2multi(c,mline);
      end if;
   end loop;
   /*
   || Print individual words in sentence
   */

   for i in 1..mline.num_rows loop
      htp.print('Word ' || i || ' is ');
      htp.print(mline.rows(i) || '<br>');
   end loop;

   /*
   || Modified to print a nice little input box
   */
   htp.print('<form action=tokenize>');
   htp.print('<textarea rows=4 name=sentence>Enter sentence here</textarea>');
   htp.print('<input type=submit>');
   htp.print('</form>');
   
EXCEPTION
   when others then
      htp.print('An error has occurred!');   

end;
 
/

